CREATE FUNCTION `fn_nextval`(`v_name` varchar(32)) RETURNS int
BEGIN
	DECLARE v_val int;

	SELECT `value` INTO v_val FROM ta_sequence WHERE `name` = v_name;
	
	IF v_val IS NULL THEN
		INSERT INTO ta_sequence (`name`) VALUES (v_name);
		SET v_val = 0;
	END IF;

	SET v_val = v_val + 1;
	
	UPDATE ta_sequence SET `value` = v_val WHERE `name` = v_name;

	RETURN v_val;
END;;

CREATE PROCEDURE `pro_application_daily`(IN `lstr_day` varchar(32))
BEGIN
	
	DECLARE ls_type VARCHAR(60) DEFAULT 'application_daily';
	
	-- 先删除旧的
	DELETE t FROM ts_common_form t WHERE t.st_type = ls_type AND t.`name` = lstr_day;
	
	-- 再新增新的
	INSERT INTO ts_common_form (st_type, `name`, `value`)
	SELECT ls_type, lstr_day, count( 1 ) 
	FROM
		ta_application t 
	WHERE
		DATE_FORMAT( t.create_date, '%Y-%m-%d' ) = lstr_day  -- lstr_day 格式 YYYY-MM-DD
		AND t.`status` > - 1;
	

END;;

CREATE EVENT `job_application_daily`
ON SCHEDULE
EVERY 1 DAY STARTS '2022-05-29 23:20:00'
DO call pro_application_daily(DATE_FORMAT(NOW(), '%Y-%m-%d'));

